<!-- manual page source format generated by PolyglotMan v3.0.7, -->
<!-- available via anonymous ftp from ftp.cs.berkeley.edu:/ucb/people/phelps/tcltk/rman.tar.Z -->

<HTML>
<HEAD>
<TITLE>Man page for s2c.1</TITLE>
</HEAD>
<BODY bgcolor=white>
<A HREF="#toc">Table of Contents</A><P>

<H2><A NAME="sect0" HREF="#toc0">Name</A></H2>

<P>
s2c - convert a SUIF file to C

<H2><A NAME="sect1" HREF="#toc1"><B>Synopsis</B></A></H2>

<P>
<B>s2c</B> [ <I>options</I> ] SUIF-file [C-file]

<H2><A NAME="sect2" HREF="#toc2"><B>Description</B></A></H2>

<P>
The <I>s2c</I> program reads the specified SUIF file and prints
out its translation into the Standard C language, if possible.
If the <I>C-file</I> specification is given, it is used
for output, otherwise the C code is written to standard
output.
<P>
The output conforms to the ANSI/ISO specifications for
Standard C. Each output file is self contained and does
not use <I>#include</I> to include any other files. The output
is <I>not</I> machine independent, however. The SUIF system
determines the sizes of all data types and the locations
of fields in structures and elements in arrays. To produce
C output that retains type information for debugging,
readability of the C code, and to allow for easier optimizations
by the back-end C compiler, SUIF structures and
arrays are translated into the corresponding C types, and
direct structure and array accesses are translated into
their C versions. In doing all of this, <I>s2c</I> makes assumptions
about how the back-end C compiler will lay out and
align the data within structures and arrays. It also must
make assumptions about sizes of all types when doing
pointer arithmetic or array indexing.
<P>
For these reasons, the C compiler used as a back end must
use the same data size, alignment, and layout rules used
by <I>snoot,</I> the SUIF C front end. If a particular existing
C compiler is to be used as a back end for SUIF, <I>snoot</I>
must have its configuration parameters set up to match
that compiler. See the <I>snoot</I> documentation for more
information.

<H2><A NAME="sect3" HREF="#toc3"><B>Options</B></A></H2>

<P>
<B>-logic-simp</B><BR>

Do simple logical simplification on the resulting C
code before writing it.

<DL>

<DT><B>-pseudo</B></DT></DT>
<DD>
Write pseudo-C code if the SUIF code cannot be represented
by correct C code. This can happen, for
example, if the SUIF code uses integer types with a
size different from any of those available in the
target C compiler. The default is to abort if correct
C code cannot be written. In either case, a
diagnostic message is printed to standard output.
</DD>
</DL>
<P>
The pseudo-C written sticks as close to C as possible.
The idea is that even if the C code can't be
run, the pseudo-C provides an easy-to-read way of
looking at the contents of a SUIF file.

<DL>

<DT><B>-keep-casts</B></DT></DT>
<DD>
Put a C type cast everywhere there was a SUIF convert
instruction. The default is to fold type
casts away where C would implicitly do type conversion
anyway.
</DD>

<DT><B>-omit-header</B></DT></DT>
<DD>
Omit the header comment that normally comes at the
very top of the output C file. By default this
header is inserted to record when the file was created
and exactly what version of <I>s2c</I> created it.
</DD>

<DT><B>-no-warn</B></DT></DT>
<DD>
Do not issue any warning messages.
</DD>

<DT><B>-always-intnum</B></DT></DT>
<DD>
When writing integer types, never use C types,
always use pseudo-types of the form <B>int</B><I>n</I> where <I>n</I> is
the size in bits, e.g. <B>int8</B> instead of <B>char.</B>
</DD>

<DT><B>-array-exprs</B></DT></DT>
<DD>
Write out SUIF array expressions directly as if C
allowed array expressions. By default, SUIF
expressions with array type are handled by casting
their locations to pointers to dummy structures of
the appropriate size and then using the structure
type to access them. The semantics of C turn anything
with array type into a pointer and implicitly
take the location of it, so expressions of array
type cannot exist in real C code. With this
option, the output is not valid C, and cannot even
be evaluated with any consistent semantics, because
both arrays and locations of arrays are written the
same way and cannot be distinguished. This flag
exists to make certain unusual kinds of SUIF code
more readable.
</DD>

<DT><B>-annotes-all</B></DT></DT>
<DD>
Write out all annotations on the SUIF code as C
comments. Annotations used internally by <I>s2c</I> cannot
be written out as comments, but all others will
be.
</DD>

<DT><B>-annotes-named</B> <I>name</I></DT></DT>
<DD>
Write out all annotations with the annotation name
<I>name.</I> No other annotations will be written unless
they are specified by other command-line options.
</DD>

<DT><B>-annotes-opcode</B> <I>opcode</I></DT></DT>
<DD>
Write out all annotations on instructions with
opcode <I>opcode.</I>
</DD>

<DT><B>-annotes-object-kind</B> <I>kind</I></DT></DT>
<DD>
Write out all the annotations on one specific kind
of object, where <I>kind</I> is one of the following:
</DD>
</DL>
<P>
<B>fses</B> -- all file set entries
<P>
<B>nodes</B> -- all tree nodes (except tree_instr nodes,
because no permanent annotations are allowed on
tree_instrs)
<P>
<B>loops</B> -- all ``loop'' nodes
<P>
<B>fors</B> -- all ``for'' nodes
<P>
<B>ifs</B> -- all ``if'' nodes
<P>
<B>blocks</B> -- all ``block'' nodes
<P>
<B>all-instrs</B> -- all instructions
<P>
<B>symtabs</B> -- all symbol tables
<P>
<B>all-syms</B> -- all symbols
<P>
<B>vars</B> -- all variable symbols
<P>
<B>proc-syms</B> -- all procedure symbols
<P>
<B>labels</B> -- all label symbols
<P>
<B>var-defs</B> -- all variable definitions
<P>
<B>types</B> -- all types

<DL>

<DT><B>-gcc-bug</B></DT></DT>
<DD>
Write C code that uses a work-around to avoid a bug
in the way gcc handles initialization of unnamed
bit-fields. The ANSI rules say that unnamed bit
fields are to be ignored in initialization of
structures, and <I>s2c</I> assumes this when writing output
code. Currect versions of gcc, however, try to
assign initializers to the unnamed bit fields and
all the initializers get assigned to the wrong
fields, resulting in compile-time warnings and
errors, and run-time failures. The work-around
causes <I>s2c</I> to put in named fields to replace
unnamed bit fields whenever possible.
</DD>

<DT><B>-drop-bounds</B></DT></DT>
<DD>
Make for bounds into temporary variables if they
contain loads, uses of symbols with their addresses
possibly taken, including global variables, or SUIF
intrinsics that might be turned into control-flow,
such as io_max instructions or io_gen macros. The
idea is to make sure it is clear to the back-end C
compiler that the bounds are loop invariant, so
loop optimizations such as software pipelining may
be done.
</DD>

<DT><B>-ll-suffix</B></DT></DT>
<DD>
If the type of an integer constant is ``long long''
use the suffix ``ll'' and if the type is ``unsigned
long long'' use the suffix ``ull'' instead of trying
to cast the constant to the given type. This
is an extension to the ANSI ``l'' and ``ul'' suffixes
on integer constants. Since ``long long''
types are not part of the ANSI C standard, the
standard says nothing of suffixes for integer constants
to get these types. This is left as an
optional switch because some implementations that
accept ``long long'' might not accept these two new
suffixes. The idea is to keep the default behavior
as portable as possible.
</DD>

<DT><B>-explicit-zero-init</B></DT></DT>
<DD>
Make all initializations to zero explicit. Normally,
static data that is initiailized to zero is
given no explicit initialization unless it's the
initialization of a structure or array with nonzero
initializers to come, in which case some zero
initializers are needed to position the non-zero
initializers properly. This takes advantage of the
fact that ANSI C guarantees all static data is
implicitly initialized to zero if there is no
explicit initialization. This flag overrides that
feature to force explicit initialization even when
the data is zero. This flag may be useful under
some circumstances when using a Solaris C compiler
as a back-end compiler, because the Solaris compiler
reportedly puts explicitly and implicitly
initialized data in different segments. This
causes the source code to bison to break because
bison redefines optind, which is also in libc, and
which segment optind is in determines which version
of optind the linker tries to use.
</DD>

<DT><B>-limit-escape-sequences</B></DT></DT>
<DD>
Do not produce simple alphabetic escape sequences
other than \n in string constants or string literals.
That is, no \a, \b, \f, \r, \t, or \v.
Instead, other representations, such as \007, are
used. This is a work-around for some back-end compilers
that don't recognize all the ANSI C required
alphabetic escape sequences. The DEC OSF 3.2 cc
compiler, for example, doesn't recognize \a.
</DD>

<DT><B>-fill-field-space-with-char-arrays</B></DT></DT>
<DD>
Use character arrays to pad structures instead of
bit fields, when possible. This is a work-around
for back-end compilers that lay out bit fields differently.
</DD>
</DL>

<H2><A NAME="sect4" HREF="#toc4"><B>Annotations</B></A></H2>

<P>
The <I>s2c</I> program reserves all annotations names beginning
with the prefix ``s2c `' for its own use. Some annotations
it uses internally, and some are recognized on input
files and may be used to affect the behavior of <I>s2c.</I> The
following are the annotations <I>s2c</I> recognizes on its input.
<P>
<B>``s2c</B> <B>comments''</B><BR>

This annotation is used to specify comments to be
inserted into the C code. Its data should be a
list of any number of strings, each of which is
interpreted as a separate comment. Each comment
should consist of all the text between the ``/*''
and ``*/'' markers. Comments can be put on SUIF
``mark'' instructions, in which case they will be
put on lines of their own, or they may be put on
any other SUIF object and they will be put in the C
code near the C code that most directly results
from that SUIF object.
<P>
<B>``s2c</B> <B>pragma''</B><BR>

This annotation is used to specify pragmas to be
inserted into the C code. <I>s2c</I> looks for this annotation
on file_set_entries, symbol tables, and
io_mrk instructions. There may be multiple pragma
annotations on an object. Each such annotation
generates one pragma line in the output.
<P>
The exact form of the output line is the string
``#pragma'' followed by a space followed by the
printed representations of the immeds in the annotation,
separated by a space if there are multiple
immeds. Strings are printed without extra quotes
around them or any other interpretation, so a
pragma annotation with a single string immed as its
data allows the form of the pragma line to be specified
exactly. All other immeds are printed in
natural ways.
<P>
An example of the use of this annotation would be
with a global symbol table containing an annotation
of
<P>
pragma": no side effects &lt;sqrt,0&gt;]
<P>
which would give this output line:
<P>
<B>``s2c</B> <B>preamble</B> <B>pragma''</B><BR>

This annotation is is just like the ``s2c pragma''
annotation except that it only has an effect when
it is placed on the global symbol table and the
pragmas for this annotation are printed before the
declarations for the global symbol table instead of
after those declarations.
<P>
<B>``s2c</B> <B>pound</B> <B>line''</B><BR>

This annotation provides a general way to insert
pre-processing directives into the C code. They
are similar to ``s2c pragma'' annotation except
that instead of beginning with ``#pragma'' and a
space, the lines in the C code begin with only
``#'' and no space, followed directly by the
immeds.    This allows ``#define'', ``#ifdef'',
``#line'', or any other pre-processing directives
at all to be inserted into the code. Whoever creates
these annotations is of course responsible for
insuring that they are valid pre-processing directives
and that they interact properly with whatever
else <I>s2c</I> puts in the C file.
<P>
An example of the use of this annotation would be
with an io_mrk instruction containing an annotation
of
<P>
pound line": line 37 \"file.c\""]
<P>
which would give this output line:
<P>
<B>``s2c</B> <B>genop</B> <B>format''</B><BR>

This annotation may be used on the global symbol
table to specify the way that SUIF ``io_genop''
instructions    will be written.    Note that
``io_genop'' instructions cannot in general be
translated to valid C code, so this annotation is
useful only with the <I>-pseudo</I> command-line option.
In that case, <I>s2c</I> functions to make the SUIF code
easy to read for a human. To that end, this annotation
allows flexibility in the way ``io_genop''
instructions are written.
<P>
There are two forms that are recognized for the
data of this annotation. The first is two strings.
The first string specifies the name of a ``genop''
and the other is a format string for printing the
``genop''. The other form for the data is a
string, then an integer, then another string. In
this case the first and last string have the same
meanings as before, but the integer specifies the
number of arguments, and only ``genop''s with that
number of arguments use that format string.
<P>
For each ``genop'' to be printed, if there is a
format annotation specifying the right number of
arguments, that is used. Otherwise, if there is a
format annotations not specifying anything about
arguments, that is used. If neither of these cases
apply, the default method of printing ``genop''
instructions is used: they are printed as function
calls with the name of the ``genop'' as the function
name.
<P>
Each format string is interpreted as follows. The
``%'' character is used as an escape in the format
string -- other characters are generally printed
directly. The following escape sequences are recognized:

<DL>

<DT>* %% </DT></DT>
<DD>        -- print one ``%'' character
</DD>

<DT>* %a </DT></DT>
<DD>        -- print one of the arguments
* %n <I>text</I> %m -- print all remaining unmatched
arguments,
separated by <I>text</I> if there is
more than
one, or nothing if there are
no unmatched
arguments
</DD>
</DL>
<P>
Note that there can be any number of ``%a'' directives,
possibly before and after the ``%n'' directive,
but there may only be one ``%n'' directive.
Arguments to all ``%a'' directives are matched
first, either from the beginning of the argument
list for those preceeding a ``%n'' directive or
from the end for those coming after one. It is an
error for there to be too few arguments to match
all ``%a'' directives, but it is not an error to
have too many arguments.
<P>
Within a ``%n'' directive, the <I>text</I> string may
include ``%%'', which translates to one ``%'', but
no other occurances of ``%''.
<P>
Note that the default format if nothing else is
given is equivalent to ``&lt;name&gt;(%n, %)'' if there
are any arguments or ``&lt;name&gt;'' if there are no
arguments, where &lt;name&gt; is the name of the generic
instruction.

<DL>

<DT>EXAMPLES:</DT></DT>
<DD>
</DD>

<DT>Format </DT></DT>
<DD>                   output
</DD>

<DT>fun(%n, %) </DT></DT>
<DD>fun() <A HREF="man_fun.op1.html">fun(op1)</A>
 fun(op1, op2)"
fun(op1, op2, op3)"
</DD>

<DT>fun() </DT></DT>
<DD>       fun() fun()    fun()"
fun()"
{%a: %n, %m} &lt;error&gt; {op1: } {op1: op2}"
{op1: op2, op3}"
</DD>

<DT>%a ? %a : %a &lt;error&gt; &lt;error&gt; </DT></DT>
<DD>   &lt;error&gt;
op1 ? op2 : op3"
</DD>
</DL>

<H2><A NAME="sect5" HREF="#toc5"><B>See</B> <B>Also</B></A></H2>

<P>
<A HREF="man_snoot.1.html">snoot(1)</A>


<H2><A NAME="sect6" HREF="#toc6"><B>History</B></A></H2>

<P>
Robert French wrote an <I>s2c</I> program for an earlier version
of the SUIF system. Due primarily to limitations of the
SUIF format of that time, the output of the early version
wasn't quite correct C code, but instead provided a useful
way to format a SUIF file for easy reading. Todd Smith
updated portions of the code to compensate for drastic
changes in the SUIF system. Chris Wilson made more
updates and rewrote parts of the program to produce correct
C output.
<P>

<HR><P>
<A NAME="toc"><B>Table of Contents</B></A><P>
<UL>
<LI><A NAME="toc0" HREF="#sect0">Name</A></LI>
<LI><A NAME="toc1" HREF="#sect1">Synopsis</A></LI>
<LI><A NAME="toc2" HREF="#sect2">Description</A></LI>
<LI><A NAME="toc3" HREF="#sect3">Options</A></LI>
<LI><A NAME="toc4" HREF="#sect4">Annotations</A></LI>
<LI><A NAME="toc5" HREF="#sect5">See Also</A></LI>
<LI><A NAME="toc6" HREF="#sect6">History</A></LI>
</UL>
</BODY></HTML>
